#include "debug.h"
#include "mass.h"
#include "field.h"
#include "SDL.h"
#include <stdio.h>

Mass * watchedMass = NULL;

void Assertions()
{
#if INT_MIN >= 0
#error I assumed int would be always signed but it is not.
#endif
  /* unsure about C ...umm... seems to work well :-)
     Redesign DoFlattening() in mass.c in case it fails. */
  assert(((int*)100) - ((int*)(100-sizeof(int))) == ((int)1)); 
  {
    int a, b, c;
    a = INT_MAX;
    b = 1;
    /* I read some compilers would give a runtime error here...
       let's see. */
    c = a + b;
    assert(c<0);
    /* this will be heavily used for wrapping around the map */
    assert((((a&0xFF) + (b&0xFF)) & 0xFF) == (c&0xFF));
    /* K&R says this is implementation dependant. I rely on it in some
       places, so let it fail just in case. */
    c = -7;
    assert(c >> 1 == -4);
  }
}

inline void DebugLevel(int level, const char *format, ... ) 
{
  va_list ap;

  if (DEBUGLEVEL < level) return;

  va_start(ap, format);
  vfprintf(stdout, format, ap);
  fflush(stdout);
}

#ifdef DEBUG_CODE_NEEDS_REVIEW
void DebugPause(Mass * troubleMass, const char *format, ... ) 
{
  va_list ap;

  watchedMass = troubleMass;
  va_start(ap, format);
  vfprintf(stdout, format, ap);
  fflush(stdout);
}

#endif

int FieldChecksum()
{
  int x, y;
  int sum = 0;
  for (x=0; x<FIELDSIZE; x++) for (y=0; y<FIELDSIZE; y++) {
    sum += FieldXY(x, y)->height;
  }
  return sum;
}

