#ifndef __DEBUG_H__
#define __DEBUG_H__

/* enable standard debugging */
#ifndef NDEBUG
#ifndef DEBUG
#define DEBUG
#endif
#endif
/* expensive debugging: correct typos */
#ifdef HEAVY_DEBUG
#define DEBUG_HEAVY
#endif
#ifdef DEBUG_HEAVY
#define HEAVY_DEBUG
#endif
/* for verbosity; maximum is 4 */
#define DEBUGLEVEL 2
#define ASSERT_WARN_ONLY 0

#if ASSERT_WARN_ONLY
#include <stdio.h>
/* FIXME: that's perhaps not the clean way... look up assert.h */
#define assert(x) if (!(x)) printf(__FILE__ ":%d Assertion " #x " failed.\n", __LINE__)
#else
#include <assert.h>
#endif

#include <stdarg.h>
#include "field.h"

/*
#define DebugLevel0(x) printf(__FUNCTION__": "x,##args)
#define DebugLevel1(x) printf(__FUNCTION__": "x,##args)
#define DebugLevel2(x) printf(__FUNCTION__": "x,##args)
#define DebugLevel3(x) printf(__FUNCTION__": "x,##args)
*/

// assumptions I did while coding this, as well as things I'm not sure about C
extern void Assertions();
/* print debugging message; level=0: always print it */
extern void DebugLevel(int level, const char * format, ... );
/* finish the current round and pause game then */
extern void DebugPause(Mass * troubleMass, const char * format, ...);

/* mark this mass in the debug display */
extern Mass * watchedMass;
/* draw all the debug stuff on the screen; called from main() */
extern void DrawDebug();
/* calculate a checksum over the game */
extern int FieldChecksum();

#endif
