#ifndef __MASSES__
#define __MASSES__

#include "mass.h"

/*
 * Functions that create real masses
 */

// TODO: BorderMass

extern Mass * CreateGrowingWallMass(int x, int y);
extern Mass * CreateLivingWallMass(int x, int y);
extern Mass * CreateMazeWall(int x, int y);
extern Mass * CreateGrowingFoodMass(int x, int y);
extern Mass * CreateGrowingShrinkMass(int x, int y);
extern Mass * CreatePlayerMass(int x, int y, int playernr);

extern Mass * CreateBombMass(int x, int y);
extern Mass * CreateProjectilMass(int x, int y);
extern Mass * CreateMassattackMass(Point target);
extern Mass * CreateAvoidPointMass(int x, int y);
extern Mass * CreateNexusMass(int x, int y);

/* the CoinMass is not volume- but pixel orientated */
extern Mass * CreateCoinMass(int x, int y);

/* game of life */
extern Mass * CreateCellMass(int x, int y);

/* hi-level functions that operate with masses */

#endif
