/*
 * This is not only the network code, but its internal "loopback" is
 * also used for local players or for playing back old logfiles.
 * 
 */
#ifndef __NETWORKPLAYER__
#define __NETWORKPLAYER__

#define MAX_PLAYERS 8
#define MAX_LAG 10

typedef struct {
  int exists; /* a player may suddenly be removed (eg network troubles) */
  int movex; /* -1, 0, +1 */
  int movey;
  int button1; /* 0 or 1 */
  int button2;
  /* TODO: socket, representing either the IP or NULL */
  int id; /* local players only: the "real" player number to send over
	     network */
} PlayerInput;

/* read here: */
extern PlayerInput player[MAX_PLAYERS];
extern int numPlayers;
/* write there: */
extern PlayerInput localPlayer[MAX_PLAYERS];

/* frames until a keystrike takes effect (0 for local games) */
int GetNetworkLag();

extern void InitNetworkPlayer();
extern void CleanupNetworkPlayer();
extern void FreeNetworkPlayer();

/* send and receive network data, returns when currentFrame is
   ready. Updates player[]. */
extern int UpdatePlayerInput(int currentFrame);

/* localPlayer[id] is going to play */
extern void AddLocalPlayer(int id);
/* ignore input from localPlayer[id] */
//extern int?? RemoveLocalPlayer(int id);

#endif

